from sense_hat import SenseHat
import csv
import time
sense = SenseHat()
sense.clear()

def stopRecording():
    sense.show_letter("N")
        
    
def recording():
    sense.show_letter("R")
    recording = True
    while True:
        for event in sense.stick.get_events():
            if event.action == "pressed":
                if event.direction == "down":
                    sense.show_letter("N")
                    recording = False
                if event.direction == "up":
                    sense.show_letter("R")
                    recording = True
                if event.direction == "left":
                    with open('data.csv','a',newline='') as csvfile:
                        csvfile.truncate()
                        csvfile.close()
                    sense.show_letter("T")
                    time.sleep(0.5)
                    sense.clear()
        o = sense.get_orientation()
        pitch= o["pitch"]
        roll = o["roll"]
        yaw = o["yaw"]
        acceleration = sense.get_accelerometer_raw()
        x = abs(acceleration['x'])
        y = abs(acceleration['y'])
        z = abs(acceleration['z'])
        with open('/home/pi/Desktop/data.csv','a',newline='') as csvfile:
            fieldNames = ['Pitch','Roll','Yaw','X','Y','Z']    
            writer = csv.DictWriter(csvfile,fieldnames=fieldNames)
            if recording:
                writer.writerow({'Pitch':pitch,'Roll':roll,'Yaw':yaw,'X':x,'Y':y,'Z':z})
            else:
                pass
        csvfile.close()
        time.sleep(0.5)
            

while True:
    sense.stick.direction_up = recording
    sense.stick.direction_down = stopRecording
    
