from sklearn import svm
import pandas as pd
import numpy as np 
from sklearn.model_selection import train_test_split  
from sklearn.metrics import classification_report, confusion_matrix  
import csv
import pickle

Pitch = []
Roll = []
Yaw = []
X = []
Y = []
Z = []
Class = []
colmap = {1:'red',2:'green',3:'blue'}					

def changeofDegree(v1,v2):
	if abs((float(v1) - float(v2))) < 180:
		return abs((float(v1) - float(v2)))
	else:
		return 360 - abs((float(v1) - float(v2)))

def importChangeofData(csvname,classInput):
	with open(csvname) as csvfile:
		reader = csv.reader(csvfile)
		row = reader.next()
		while True:
			if(len(row) > 1):	
				try:
					# reader.next()
					# reader.next()
					cur_row = reader.next()
					Pitch.append(changeofDegree(cur_row[0],row[0]))
					Roll.append(changeofDegree(cur_row[1],row[1]))
					Yaw.append(changeofDegree(cur_row[2],row[2]))
					X.append(changeofDegree(cur_row[3],row[3]))
					Y.append(changeofDegree(cur_row[4],row[4]))
					Z.append(changeofDegree(cur_row[5],row[5]))
					Class.append(classInput)
					row = cur_row
				except:
					break


importChangeofData('stilltestdata.csv',0)
importChangeofData('newStanding_edit.csv',0)
importChangeofData('10minRun1.csv',2)
importChangeofData('10minRun2.csv',2)
importChangeofData('runtestdata.csv',2)
importChangeofData('leftLegWalk.csv',1)
importChangeofData('RightLegWalk.csv',1)
importChangeofData('walktestdata.csv',1)
importChangeofData('WalkinginCircles.csv',1)

# importChangeofData('ankleStanding.csv',0)
# importChangeofData('ankleWalking.csv',1)
# importChangeofData('ankleRunning.csv',2)

# importChangeofData('wristStanding.csv',0)
# importChangeofData('wristWalking.csv',1)
# importChangeofData('wristRunning.csv',2)

#importChangeofData('outliner.csv',3)
df = pd.DataFrame({
	'x': X,
	'y':Y,
	'z':Z,
	'Pitch': Pitch,
	'Roll': Roll,
	'Yaw': Yaw,
	'Class': Class
	})

X = df.drop('Class', axis=1)
y = df['Class']
X_train, X_test, y_train, y_test = train_test_split(X, y, test_size = 0.20)
clf = svm.SVC(kernel='linear')
clf.fit(X_train,y_train)

y_pred = clf.predict(X_test) 
print(confusion_matrix(y_test,y_pred))  
print(classification_report(y_test,y_pred))   
# filename = "Saved_model.sav"
# pickle.dump(clf, open(filename, 'wb'))