from sklearn import svm
import pandas as pd
import numpy as np 
from sklearn.model_selection import train_test_split  
from sklearn.metrics import classification_report, confusion_matrix  
import csv
import pickle

Pitch = []
Roll = []
Yaw = []
X = []
Y = []
Z = []
colmap = {1:'red',2:'green',3:'blue'}
			
def changeofDegree(v1,v2):
	if abs((float(v1) - float(v2))) < 180:
		return abs((float(v1) - float(v2)))
	else:
		return 360 - abs((float(v1) - float(v2)))

def importChangeofData(csvname):
	with open(csvname) as csvfile:
		reader = csv.reader(csvfile)
		row = reader.next()
		while True:
			if(len(row) > 1):	
				try:
					cur_row = reader.next()
					Pitch.append(changeofDegree(cur_row[0],row[0]))
					Roll.append(changeofDegree(cur_row[1],row[1]))
					Yaw.append(changeofDegree(cur_row[2],row[2]))
					X.append(changeofDegree(cur_row[3],row[3]))
					Y.append(changeofDegree(cur_row[4],row[4]))
					Z.append(changeofDegree(cur_row[5],row[5]))
					row = cur_row
				except:
					break

importChangeofData('newStanding_edit.csv')
importChangeofData('10minRun1.csv')
importChangeofData('10minRun2.csv')
importChangeofData('leftLegWalk.csv')
importChangeofData('RightLegWalk.csv')
importChangeofData('runtestdata.csv')
importChangeofData('walktestdata.csv')
importChangeofData('stilltestdata.csv')

inlinerdf = pd.DataFrame({
	'x': X,
	'y':Y,
	'z':Z,
	'Pitch': Pitch,
	'Roll': Roll,
	'Yaw': Yaw
	})

Pitch = []
Roll = []
Yaw = []
X = []
Y = []
Z = []

# for n in range(14,16,1):
	# ga = 0.00000000001
	# while ga < 1:
	# 	nu = n / 100.00
inlinerdf_train, inlinerdf_test = train_test_split(inlinerdf, test_size = 0.20)
clf = svm.OneClassSVM(nu=0.1, kernel="rbf",gamma = 0.0001)
clf.fit(inlinerdf_train)

pred_train = clf.predict(inlinerdf_train)
pred_test = clf.predict(inlinerdf_test)
n_pass_train = pred_train[pred_train == 1].size
n_pass_test = pred_test[pred_test == 1].size
per_pass_train = (float(n_pass_train) / pred_train.size) * 100 
per_pass_test = (float(n_pass_test) / pred_test.size) * 100

# print("%f %f %d %d " %(nu,ga,per_pass_train, per_pass_test))
print("%d %d " %(per_pass_train, per_pass_test))
		# ga = ga * 10


filename = "Outliner_Saved_model.sav"
pickle.dump(clf, open(filename, 'wb'))