from sklearn import svm
import pandas as pd
import numpy as np 
from sklearn.model_selection import train_test_split  
from sklearn.metrics import classification_report, confusion_matrix  
import csv
import pickle

Pitch = []
Roll = []
Yaw = []
X = []
Y = []
Z = []
Class = []
colmap = {1:'red',2:'green',3:'blue'}					

def changeofDegree(v1,v2):
	if abs((float(v1) - float(v2))) < 180:
		return abs((float(v1) - float(v2)))
	else:
		return 360 - abs((float(v1) - float(v2)))

def importChangeofData(csvname,classInput):
	with open(csvname) as csvfile:
		reader = csv.reader(csvfile)
		row = reader.next()
		while True:
			if(len(row) > 1):	
				try:
					cur_row = reader.next()
					Pitch.append(changeofDegree(cur_row[0],row[0]))
					Roll.append(changeofDegree(cur_row[1],row[1]))
					Yaw.append(changeofDegree(cur_row[2],row[2]))
					X.append(changeofDegree(cur_row[3],row[3]))
					Y.append(changeofDegree(cur_row[4],row[4]))
					Z.append(changeofDegree(cur_row[5],row[5]))
					Class.append(classInput)
					row = cur_row
				except:
					break


importChangeofData('stilltestdata.csv',0)
importChangeofData('newStanding_edit.csv',0)
importChangeofData('10minRun1.csv',2)
importChangeofData('10minRun2.csv',2)
importChangeofData('runtestdata.csv',2)
importChangeofData('leftLegWalk.csv',1)
importChangeofData('RightLegWalk.csv',1)
importChangeofData('walktestdata.csv',1)
importChangeofData('WalkinginCircles.csv',1)

df = pd.DataFrame({
	'x': X,
	'y':Y,
	'z':Z,
	'Pitch': Pitch,
	'Roll': Roll,
	'Yaw': Yaw,
	'Class': Class
	})

Pitch = []
Roll = []
Yaw = []
X = []
Y = []
Z = []
Class = []

importChangeofData('SecoundpersonStanding.csv',0)
importChangeofData('SecoundpersonWalking.csv',1)
importChangeofData('SecoundpersonRunning.csv',2)

testdf = pd.DataFrame({
	'x': X,
	'y':Y,
	'z':Z,
	'Pitch': Pitch,
	'Roll': Roll,
	'Yaw': Yaw,
	'Class': Class
	})


x = df.drop('Class', axis=1)
y = df['Class']

clf = svm.SVC(kernel='linear')
clf.fit(x,y)

x_test = testdf.drop('Class', axis=1)
y_test = testdf['Class']

y_pred = clf.predict(x_test) 
print(confusion_matrix(y_test,y_pred))  
print(classification_report(y_test,y_pred))