from sklearn import svm
import pandas as pd
import numpy as np 
from sklearn.model_selection import train_test_split  
from sklearn.metrics import classification_report, confusion_matrix  
import csv

def changeofDegree(v1,v2):
	if abs((float(v1) - float(v2))) < 180:
		return abs((float(v1) - float(v2)))
	else:
		return 360 - abs((float(v1) - float(v2)))

def importChangeofData(csvname,iPitch,iRoll,iYaw,iX,iY,iZ):
	with open(csvname) as csvfile:
		reader = csv.reader(csvfile)
		row = reader.next()
		while True:
			if(len(row) > 1):	
				try:
					cur_row = reader.next()
					iPitch.append(changeofDegree(cur_row[0],row[0]))
					iRoll.append(changeofDegree(cur_row[1],row[1]))
					iYaw.append(changeofDegree(cur_row[2],row[2]))
					iX.append(changeofDegree(cur_row[3],row[3]))
					iY.append(changeofDegree(cur_row[4],row[4]))
					iZ.append(changeofDegree(cur_row[5],row[5]))
					row = cur_row
				except:
					return [iPitch,iRoll,iYaw,iX,iY,iZ]

def findLargestRadius(array,centerpoint):
	radius = 0
	for a in array:
		if abs(centerpoint - a) > radius:
			radius = abs(centerpoint - a)
	return radius

def addingTemptoArray(array,temp):
	for t in range(len(temp)):
		array.append(temp[t])

	return array

def findRadiusArray(csvs):
	Pitch = []
	Roll = []
	Yaw = []
	X = []
	Y = []
	Z = []
	
	for csv in csvs:
		temp = importChangeofData(csv,Pitch,Roll,Yaw,X,Y,Z)
		Pitch = addingTemptoArray(Pitch,temp[0])
		Roll = addingTemptoArray(Roll,temp[1])
		Yaw = addingTemptoArray(Yaw,temp[2])
		X = addingTemptoArray(X,temp[3])
		Y = addingTemptoArray(Y, temp[4])
		Z = addingTemptoArray(Z,temp[5])

	centerpoint = [np.mean(Pitch), np.mean(Roll), np.mean(Yaw),np.mean(X),np.mean(Y),np.mean(Z)]
	radius = [findLargestRadius(Pitch,centerpoint[0]),findLargestRadius(Roll,centerpoint[1]),findLargestRadius(Yaw,centerpoint[2]),
	findLargestRadius(X,centerpoint[3]),findLargestRadius(Y,centerpoint[4]),findLargestRadius(Z,centerpoint[5])]
	return[centerpoint,radius]

def testagainstOutliners(walk,stil,run):
	Pitch = []
	Roll = []
	Yaw = []
	X = []
	Y = []
	Z = []
	count = 0
	w = 0
	s = 0
	r = 0
	with open("outliner.csv") as csvfile:
		reader = csv.reader(csvfile)
		row = reader.next()
		while True:
			if(len(row) > 1):	
				try:
					cur_row = reader.next()
					Pitch.append(changeofDegree(cur_row[0],row[0]))
					Roll.append(changeofDegree(cur_row[1],row[1]))
					Yaw.append(changeofDegree(cur_row[2],row[2]))
					X.append(changeofDegree(cur_row[3],row[3]))
					Y.append(changeofDegree(cur_row[4],row[4]))
					Z.append(changeofDegree(cur_row[5],row[5]))
					row = cur_row
				except:	
					break
		for i in range(len(Pitch)):
			if abs(Pitch[i] - still[0][0]) < still[1][0] and abs(Roll[i] - still[0][1]) < still[1][1] and abs(Yaw[i] - still[0][2]) < still[1][2] and abs(X[i] - still[0][3]) < still[1][3] and abs(Y[i] - still[0][4]) < still[1][4] and abs(Z[i] - still[0][5]) < still[1][5]:
				s = s+ 1
			elif abs(Pitch[i] - walk[0][0]) < walk[1][0] and abs(Roll[i] - walk[0][1]) < walk[1][1] and abs(Yaw[i] - walk[0][2]) < walk[1][2] and abs(X[i] - walk[0][3]) < walk[1][3] and abs(Y[i] - walk[0][4]) < walk[1][4] and abs(Z[i] - walk[0][5]) < walk[1][5]:
				w = w + 1
			elif abs(Pitch[i] - run[0][0]) < run[1][0] and abs(Roll[i] - run[0][1]) < run[1][1] and abs(Yaw[i] - run[0][2]) < run[1][2] and abs(X[i] - run[0][3]) < run[1][3] and abs(Y[i] - run[0][4]) < run[1][4] and abs(Z[i] - run[0][5]) < run[1][5]:
				r = r + 1
			else:
				count = count + 1
		print(s)
		print(w)
		print(r)
		print(count)
		print(len(Pitch))
still = findRadiusArray(['newStanding_edit.csv','stilltestdata.csv'])
walk = findRadiusArray(['leftLegWalk.csv','RightLegWalk.csv','walktestdata.csv'])
run = findRadiusArray(['10minRun1.csv','10minRun2.csv','runtestdata.csv'])


testagainstOutliners(walk,still,run)


# for i in range(0,1000):
# 	uniformpoints.append([(9 / 1000) * i,(9/ 1000) * i,(9 / 1000) * i,(180 / 1000) * i,(180 / 1000) * i,(180 / 1000) * i])


