from sklearn.cluster import KMeans
import pandas as pd
import numpy as np 
import matplotlib.pyplot as plt
from mpl_toolkits.mplot3d import axes3d
import csv
import copy

Pitch = []
Roll = []
Yaw = []
X = []
Y = []
Z = []
colmap = {1:'red',2:'green',3:'blue'}
def importCsvdata(csvname):
	with open(csvname) as csvfile:
		reader = csv.reader(csvfile)
		row = reader.next()
		
		while  True:
			if(len(row) > 1):
				try:	
					row[3] = float(row[3])
					row[4] = float(row[4])
					row[5] = float(row[5])

					X.append(row[3])
					Y.append(row[4])
					Z.append(row[5])
					row = reader.next()
				except:
					del X[-1]
					del Y[-1]
					del Z[-1]
					break
					

def changeofDegree(v1,v2):
	if abs((float(v1) - float(v2))) < 180:
		return abs((float(v1) - float(v2)))
	else:
		return 360 - abs((float(v1) - float(v2)))

def importChangeofData(csvname):
	with open(csvname) as csvfile:
		reader = csv.reader(csvfile)
		row = reader.next()
		while True:
			if(len(row) > 1):	
				try:
					cur_row = reader.next()
					Pitch.append(changeofDegree(cur_row[0],row[0]))
					Roll.append(changeofDegree(cur_row[1],row[1]))
					Yaw.append(changeofDegree(cur_row[2],row[2]))
					row = cur_row
				except:
					break

def exportcentroidsToCSV(centroids,csvname):
	with open(csvname,"a") as csvfile:
		csvfile.truncate()
		fieldNames = ['Pitch','Roll','Yaw','X','Y','Z']
		writer = csv.DictWriter(csvfile,fieldnames=fieldNames)
		for centroid in centroids:
			writer.writerow({'Pitch':centroid[0], 'Roll':centroid[1], 'Yaw': centroid[2], 'X': centroid[3], 'Y': centroid[4], 'Z': centroid[5]})
	csvfile.close()

importCsvdata('StandingStill10Mins.csv')
importCsvdata('10minRun1.csv')
importCsvdata('10minRun2.csv')
importCsvdata('leftLegWalk.csv')
importCsvdata('RightLegWalk.csv')

importChangeofData('StandingStill10Mins.csv')
importChangeofData('10minRun1.csv')
importChangeofData('10minRun2.csv')
importChangeofData('leftLegWalk.csv')
importChangeofData('RightLegWalk.csv')

print(len(X))
df = pd.DataFrame({
	'x': X,
	'y':Y,
	'z':Z,
	'Pitch': Pitch,
	'Roll': Roll,
	'Yaw': Yaw
	})


kmeans = KMeans(n_clusters=3)
kmeans.fit(df)
labels = kmeans.predict(df)
centroids = kmeans.cluster_centers_
exportcentroidsToCSV(centroids,"centroids.csv")